%{
#include <signal.h>     
#include <dirent.h>     
#include <pwd.h>        
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>

#include "cmdline.h"
#include "tok.h"
#include "exec.h"

#include "math.h"

char *s; //    

extern int yylex();
extern char* yytext;
extern int yyleng;
extern FILE* yyin;
extern FILE* yyout;

static int fd[2];
static int i;
static char bufd[127];

int yyerror(char* se)
{
    while( yylex() );
    fprintf(stderr,"retsh: %s\n",se); 
}
void setcwd() /*     */
{
 char cwd[512];
 getcwd(cwd,512); setenv( "CWD", cwd, 1 );
}
#define CHDIR(D) { char* d=D; if(chdir(d) < 0)
 \
	fprintf(stderr,"retsh:     `%s`\n", d );
 else setcwd();}
static double STACK[100];
static int sp=0;
static double d;
void push(double p)
{
 if( sp == 100 ) fprintf(stderr,"retsh:    .\n");
 else STACK[sp++] = p;
}
double pop()
{
 if( sp == 0 ) fprintf(stderr,"retsh:  .\n");
 else return STACK[--sp];
 return 0.0;
}

%}
%token _exit _pwd _cd _cd_ _id _arg _real _echo _set _unset _getenv _setenv
%left '+' '-'
%left '*' '/' '%'
%left '^'
%left U _sin _cos
%%
command: 
    _exit { puts("retsh:  retsh ۣ"); exit(0); } |
    _pwd { char gdir[512]; printf("%s\n",getcwd(gdir,512)); } |
    _cd    {  
CHDIR((char*)getenv("HOME")); 
} |
    _cd '/' { 
CHDIR("/"); 
} |
    _cd_ { CHDIR(".."); } |
    _cd _arg { CHDIR(yytext); } |
    _echo ARGS { for(i=0; i<argn; i++) printf("%s%c",args[i],argn==i+1 ? '\n':' ');} |
    prog ARGS { args[argn]=0; cmdExec(args[0],args,environ);} |
    _set { printv();}  |
    _set prog '=' prog { setvar(args[0],args[1]); /*    */} |
    _unset _arg { unsetvar(yytext);} |
    _getenv { for(i=0; environ[i]; i++) printf("%s\n",environ[i]);} |
    _setenv _arg { setenv(yytext,(char*)strdup((char*)findvar(yytext)),1);} |
    ;
ARGS: prog ARGS |
	'&' {fone=1;}
	| ;
prog: _arg { args[argn++]=strdup(yytext);} | ffff;
ffff: '{' e '}' { sprintf(bufd,"%g",pop()); args[argn++]=strdup(bufd);};
e: e '+' e { push( pop()+pop() );} |
   e '-' e { d=pop(); push( pop()-d );} |
   e '/' e { d=pop(); push( pop()/d );} |
   e '*' e { push( pop()*pop() );} |
   e '%' e { d=pop(); d=fmod( pop(), d ); push( d );} |
   e '^' e { d=exp( pop() * log( pop() ) ); push( d ); } |   
   '-' e %prec U { push( -pop() );} |
   _sin e { push( sin( pop() ) ); } |
   _cos e { push( cos( pop() ) ); } |
   '(' e ')' |
   x 
;

x: _arg {char* ss;
	    d=strtod(yytext,&ss); push(d);
	 if( *ss!='\0' ) fprintf(stderr,"retsh:   -  .\n");
	};
%%

void sigCHILD(int s){  waitpid(-1,NULL,WNOHANG); }

main()
{
 char *user = "root";      /*       */
 char *home = "/root";     /*    */
 int uid = getuid(); //  uid
 struct passwd *p = getpwuid(uid); // -  
  uid
 register i; // ޣ   

 if( p != NULL )
 {
    if(p->pw_name && *p->pw_name ) user = p->pw_name;
    if(               *p->pw_dir ) home = p->pw_dir;
 }
 setenv("USER", user,1); setenv("HOME", home,1);
 setvar("home", home); setvar("path", ".:/bin:/sbin:/usr/bin:/usr/sbin");

 setvar("status","0");
 
 { //   .
 sigset_t cldset; // 

    sigemptyset(&cldset); //  SIGTTOU
    sigaddset(&cldset,SIGTTOU); // 
    sigprocmask(SIG_BLOCK,&cldset,0); // 
    
    signal(SIGINT,SIG_IGN);
    signal(SIGCHLD,sigCHILD);
 }

argn = 0;
 for(;;)
 {
    for(i=0; i<argn; i++) free(args[i]);
    argn = 0;
    fone = 0;
    
    pipe(fd);
    yyin = fdopen(fd[0],"r");
    if( !yyin ) perror("retsh: "), exit(10);

    s = getcmd(); //   
    
    write(fd[1],s,strlen(s));
    close(fd[1]);
    
    yyparse(); //  
    
    close(fd[0]);
    fclose(yyin);
 }
}
